<template>
  <div class="container">
    <div class="section">
      <div>
        <h5 class="title is-5">Create Inventory</h5>
        <router-link class="button is-primary is-pulled-right" :to="{ name: 'inventory-batch' }">Batch Create</router-link>
      </div>
      <form @submit.prevent="submit">
        <div class="field">
          <label class="label">Location</label>
          <location-select
            :loading="fetchingLocation"
            v-model="location"
            :locations="locations"
          />
        </div>
        <div class="field">
          <label class="label">Item Type</label>
          <item-type-select
            :loading="fetchingItemType"
            v-model="itemType"
            :itemTypes="itemTypes"
          />
        </div>
        <div class="field">
          <label class="label">Status</label>
          <div class="control">
            <div class="select">
              <select v-model="status">
                <option
                  v-for="s in statusOptions"
                  :key="s.value"
                  :value="s.value"
                >{{ s.display }}</option>
              </select>
            </div>
          </div>
        </div>
        <div class="buttons">
          <button
            type="submit"
            class="button is-primary"
            :disabled="!validate"
          >Create</button>
        </div>
      </form>
    </div>
  </div>
</template>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Location, Repository as LocationRepository } from '@/modals/location';
  import { ItemType, Repository as ItemRepository } from '@/modals/itemType';
  import {
    InventoryStatus,
    Repository as InventoryRepository,
  } from '@/modals/inventory';

  @Component<InventoryCreatePage>({
    components: {
      LocationSelect: () => import('@/components/location/LocationSelect.vue'),
      ItemTypeSelect: () => import('@/components/itemType/ItemTypeSelect.vue'),
    },
  })
  export default class InventoryCreatePage extends Vue {
    loading: boolean = false;

    fetchingLocation: boolean = false;
    location: string = '';

    fetchingItemType: boolean = false;
    itemType: string = '';

    status: InventoryStatus = InventoryStatus.Stock;
    statusOptions = [
      { value: InventoryStatus.Stock, display: 'In Stock' },
      { value: InventoryStatus.InUse, display: 'In Use' },
      { value: InventoryStatus.Repair, display: 'Repair' },
    ];

    locations: Location[] = [];
    itemTypes: ItemType[] = [];

    mounted() {
        this.fetchLocation();
        this.fetchItemType();
    }

    fetchLocation() {
      this.fetchingLocation = true;
      return LocationRepository.list()
        .then((locations) => {
          this.locations = locations;
          this.fetchingLocation = false;
        });
    }

    fetchItemType() {
      this.fetchingItemType = true;
      return ItemRepository.list()
        .then((itemTypes) => {
          this.itemTypes = itemTypes;
          this.fetchingItemType = false;
        });
    }

    get validate() {
      return !!(this.location && this.itemType && this.status);
    }

    submit() {
      this.loading = true;
      return InventoryRepository.create({
        location: this.location,
        itemType: this.itemType,
        status: this.status,
      }).then(() => {
        this.$router.push('/');
      });
    }
  }
</script>
